<html>
<head>
<title>OGRE: Ogre::Singleton&lt; T &gt; Class Template Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li class="current"><a href="classes.html"><span>Classes</span></a></li>
    <li><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="tabs">
  <ul>
    <li><a href="classes.html"><span>Alphabetical&nbsp;List</span></a></li>
    <li><a href="annotated.html"><span>Class&nbsp;List</span></a></li>
    <li><a href="hierarchy.html"><span>Class&nbsp;Hierarchy</span></a></li>
    <li><a href="functions.html"><span>Class&nbsp;Members</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="namespaceOgre.html">Ogre</a>::<a class="el" href="classOgre_1_1Singleton.html">Singleton</a></div>
<h1>Ogre::Singleton&lt; T &gt; Class Template Reference</h1><!-- doxytag: class="Ogre::Singleton" -->Template class for creating single-instance global classes.  
<a href="#_details">More...</a>
<p>
<code>#include &lt;<a class="el" href="OgreSingleton_8h-source.html">OgreSingleton.h</a>&gt;</code>
<p>
<div class="dynheader">
Inheritance diagram for Ogre::Singleton&lt; T &gt;:</div>
<div class="dynsection">
<center><font size="2">[<a href="graph_legend.html">legend</a>]</font></center></div>

<p>
<a href="classOgre_1_1Singleton-members.html">List of all members.</a><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Singleton.html#2b0622a1223ac3a0c6b9c53e787b8d93">Singleton</a> (void)</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Singleton.html#9bc0518bb06d12629e287149cdcc4b5d">~Singleton</a> (void)</td></tr>

<tr><td colspan="2"><br><h2>Static Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static T &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Singleton.html#7757bd7ac3702c144502e53ad6491888">getSingleton</a> (void)</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">static T *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Singleton.html#7ab51c46521b89723d6186a52a7e0d7b">getSingletonPtr</a> (void)</td></tr>

<tr><td colspan="2"><br><h2>Static Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static T *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Singleton.html#d36ac06b409a2d580217328ef2cd3a01">ms_Singleton</a></td></tr>

</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
<h3>template&lt;typename T&gt;<br>
 class Ogre::Singleton&lt; T &gt;</h3>

Template class for creating single-instance global classes. 
<p>Definition at line <a class="el" href="OgreSingleton_8h-source.html#l00057">57</a> of file <a class="el" href="OgreSingleton_8h-source.html">OgreSingleton.h</a>.</p>
<hr><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" name="2b0622a1223ac3a0c6b9c53e787b8d93"></a><!-- doxytag: member="Ogre::Singleton::Singleton" ref="2b0622a1223ac3a0c6b9c53e787b8d93" args="(void)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Singleton.html">Ogre::Singleton</a>&lt; T &gt;::<a class="el" href="classOgre_1_1Singleton.html">Singleton</a>           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreSingleton_8h-source.html#l00064">64</a> of file <a class="el" href="OgreSingleton_8h-source.html">OgreSingleton.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="9bc0518bb06d12629e287149cdcc4b5d"></a><!-- doxytag: member="Ogre::Singleton::~Singleton" ref="9bc0518bb06d12629e287149cdcc4b5d" args="(void)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Singleton.html">Ogre::Singleton</a>&lt; T &gt;::~<a class="el" href="classOgre_1_1Singleton.html">Singleton</a>           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreSingleton_8h-source.html#l00074">74</a> of file <a class="el" href="OgreSingleton_8h-source.html">OgreSingleton.h</a>.</p>

</div>
</div><p>
<hr><h2>Member Function Documentation</h2>
<a class="anchor" name="7757bd7ac3702c144502e53ad6491888"></a><!-- doxytag: member="Ogre::Singleton::getSingleton" ref="7757bd7ac3702c144502e53ad6491888" args="(void)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">static T&amp; <a class="el" href="classOgre_1_1Singleton.html">Ogre::Singleton</a>&lt; T &gt;::getSingleton           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Reimplemented in <a class="el" href="classOgre_1_1ArchiveManager.html#d5b5f92045294d97c3aecddaba89de31">Ogre::ArchiveManager</a>, <a class="el" href="classOgre_1_1CompositorManager.html#3c401a0186d115243eaef438450a0b17">Ogre::CompositorManager</a>, <a class="el" href="classOgre_1_1ControllerManager.html#68fb107a5e1b3470c7381c0c1fdd36c7">Ogre::ControllerManager</a>, <a class="el" href="classOgre_1_1DynLibManager.html#8ed0226ad6fbb09423a3641f0dfd2b7b">Ogre::DynLibManager</a>, <a class="el" href="classOgre_1_1ExternalTextureSourceManager.html#48ff44556145b75d887f4162ff44237b">Ogre::ExternalTextureSourceManager</a>, <a class="el" href="classOgre_1_1FontManager.html#be141c95645655ae184fd100431f914a">Ogre::FontManager</a>, <a class="el" href="classOgre_1_1GpuProgramManager.html#215f8a158be2840363627ee55161de0c">Ogre::GpuProgramManager</a>, <a class="el" href="classOgre_1_1HardwareBufferManager.html#380063fef4a4563c90d45a03ac196dc7">Ogre::HardwareBufferManager</a>, <a class="el" href="classOgre_1_1HighLevelGpuProgramManager.html#77dc1f71e5aae0cb1e146a2a0a3ced49">Ogre::HighLevelGpuProgramManager</a>, <a class="el" href="classOgre_1_1LogManager.html#1bd6bc0890fd3e1de7886433c40b5e87">Ogre::LogManager</a>, <a class="el" href="classOgre_1_1MaterialManager.html#100f413d9d2316028e7ae740e5a43161">Ogre::MaterialManager</a>, <a class="el" href="classOgre_1_1MeshManager.html#2efefa307b7987c5fcff7e8c47f79758">Ogre::MeshManager</a>, <a class="el" href="classOgre_1_1OverlayManager.html#de527bdaf5edb3d9d080f3cf292cfca5">Ogre::OverlayManager</a>, <a class="el" href="classOgre_1_1ParticleSystemManager.html#970140febaf5f8e2dd54bfe14da7353c">Ogre::ParticleSystemManager</a>, <a class="el" href="classOgre_1_1Profiler.html#aa925dad8392fe140d017a5766f3cd49">Ogre::Profiler</a>, <a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#85e23967cb7bce8948b744e0de9af17a">Ogre::ResourceBackgroundQueue</a>, <a class="el" href="classOgre_1_1ResourceGroupManager.html#45101333f0f9ff132fc381dd5c4a1d60">Ogre::ResourceGroupManager</a>, <a class="el" href="classOgre_1_1Root.html#6c8959a647a86d6732a8a32f57b6a6ee">Ogre::Root</a>, <a class="el" href="classOgre_1_1SceneManagerEnumerator.html#137cf67285fc6ea14574db3dcf181d46">Ogre::SceneManagerEnumerator</a>, <a class="el" href="classOgre_1_1ShadowTextureManager.html#90f28dc399e6efb5f02de3115d8a0d7a">Ogre::ShadowTextureManager</a>, <a class="el" href="classOgre_1_1SkeletonManager.html#bf6b5ad96a16a1619c1d37a0e32a5517">Ogre::SkeletonManager</a>, and <a class="el" href="classOgre_1_1TextureManager.html#c6fb858ee86f3b7b75de32e3e04ee5c8">Ogre::TextureManager</a>.</p>

<p>Definition at line <a class="el" href="OgreSingleton_8h-source.html#l00076">76</a> of file <a class="el" href="OgreSingleton_8h-source.html">OgreSingleton.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="7ab51c46521b89723d6186a52a7e0d7b"></a><!-- doxytag: member="Ogre::Singleton::getSingletonPtr" ref="7ab51c46521b89723d6186a52a7e0d7b" args="(void)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">static T* <a class="el" href="classOgre_1_1Singleton.html">Ogre::Singleton</a>&lt; T &gt;::getSingletonPtr           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Reimplemented in <a class="el" href="classOgre_1_1ArchiveManager.html#460a08ab422a879e91dd154ee33c2aac">Ogre::ArchiveManager</a>, <a class="el" href="classOgre_1_1CompositorManager.html#087432078a26a4fe1c2068012f3300f3">Ogre::CompositorManager</a>, <a class="el" href="classOgre_1_1ControllerManager.html#fc3e91410cbc2f77cfff9f9b09ef60f7">Ogre::ControllerManager</a>, <a class="el" href="classOgre_1_1DynLibManager.html#34d606f2c393f90e6d2fb29194a53be7">Ogre::DynLibManager</a>, <a class="el" href="classOgre_1_1ExternalTextureSourceManager.html#70c7067c51f73b0fbf2dcf77d582bb08">Ogre::ExternalTextureSourceManager</a>, <a class="el" href="classOgre_1_1FontManager.html#9700290a1b411121902b83e46e1afc1b">Ogre::FontManager</a>, <a class="el" href="classOgre_1_1GpuProgramManager.html#1fa33935f7bc9ca113fe3adbea6493e7">Ogre::GpuProgramManager</a>, <a class="el" href="classOgre_1_1HardwareBufferManager.html#b633b90f5015dc3199f96e0514347b3b">Ogre::HardwareBufferManager</a>, <a class="el" href="classOgre_1_1HighLevelGpuProgramManager.html#9229f816e3c47a5ca351c0d667cf53a4">Ogre::HighLevelGpuProgramManager</a>, <a class="el" href="classOgre_1_1LogManager.html#26fc82537a3ea960342838f878ef0f1f">Ogre::LogManager</a>, <a class="el" href="classOgre_1_1MaterialManager.html#17b3b6ea6c91c7713769854606a58889">Ogre::MaterialManager</a>, <a class="el" href="classOgre_1_1MeshManager.html#b898923c2b46062858e28e19beb251d2">Ogre::MeshManager</a>, <a class="el" href="classOgre_1_1OverlayManager.html#ce76368f6fa68ae0dad4547c7f4be25c">Ogre::OverlayManager</a>, <a class="el" href="classOgre_1_1ParticleSystemManager.html#34314a29330b8063e1dc6f5fd3fabc63">Ogre::ParticleSystemManager</a>, <a class="el" href="classOgre_1_1Profiler.html#01ec79ba4ba7a539bfd742e120c1ff21">Ogre::Profiler</a>, <a class="el" href="classOgre_1_1ResourceBackgroundQueue.html#8560b1f597bcb32f13d4a0abbdbb2e02">Ogre::ResourceBackgroundQueue</a>, <a class="el" href="classOgre_1_1ResourceGroupManager.html#375aaff7929cfb5560d69b0056363aa0">Ogre::ResourceGroupManager</a>, <a class="el" href="classOgre_1_1Root.html#0813c15b258db16ef212dba53b72c3e4">Ogre::Root</a>, <a class="el" href="classOgre_1_1SceneManagerEnumerator.html#85109f580da806433a363792a7233fe4">Ogre::SceneManagerEnumerator</a>, <a class="el" href="classOgre_1_1ShadowTextureManager.html#9490269f8bbbdcd75fea78989b12fb99">Ogre::ShadowTextureManager</a>, <a class="el" href="classOgre_1_1SkeletonManager.html#21c2e42c7e440c04b8df6af455a27563">Ogre::SkeletonManager</a>, and <a class="el" href="classOgre_1_1TextureManager.html#3a55789d982b34bdd9daa27650360653">Ogre::TextureManager</a>.</p>

<p>Definition at line <a class="el" href="OgreSingleton_8h-source.html#l00078">78</a> of file <a class="el" href="OgreSingleton_8h-source.html">OgreSingleton.h</a>.</p>

</div>
</div><p>
<hr><h2>Member Data Documentation</h2>
<a class="anchor" name="d36ac06b409a2d580217328ef2cd3a01"></a><!-- doxytag: member="Ogre::Singleton::ms_Singleton" ref="d36ac06b409a2d580217328ef2cd3a01" args="" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">T* <a class="el" href="classOgre_1_1Singleton.html">Ogre::Singleton</a>&lt; T &gt;::<a class="el" href="classOgre_1_1Singleton.html#d36ac06b409a2d580217328ef2cd3a01">ms_Singleton</a><code> [static, protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreSingleton_8h-source.html#l00061">61</a> of file <a class="el" href="OgreSingleton_8h-source.html">OgreSingleton.h</a>.</p>

<p>Referenced by <a class="el" href="OgreSingleton_8h-source.html#l00076">Ogre::Singleton&lt; Ogre::FontManager &gt;::getSingleton()</a>, <a class="el" href="OgreSingleton_8h-source.html#l00078">Ogre::Singleton&lt; Ogre::FontManager &gt;::getSingletonPtr()</a>, <a class="el" href="OgreSingleton_8h-source.html#l00064">Ogre::Singleton&lt; Ogre::FontManager &gt;::Singleton()</a>, and <a class="el" href="OgreSingleton_8h-source.html#l00074">Ogre::Singleton&lt; Ogre::FontManager &gt;::~Singleton()</a>.</p>

</div>
</div><p>
<hr>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreSingleton_8h-source.html">OgreSingleton.h</a></ul>
<hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:53:47 2008
</p>
</body>
</html>
